using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Drawing;
using System.Runtime.Serialization;   

namespace ComboGDBG
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private Syncfusion.Windows.Forms.Grid.GridBoundColumn gridBoundColumn1;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.gridBoundColumn1 = new Syncfusion.Windows.Forms.Grid.GridBoundColumn();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(0, 0);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(292, 266);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		
		private void Form1_Load(object sender, System.EventArgs e)
		{	
			this.gridDataBoundGrid1.DataSource = GetParentTable();
			
			this.gridDataBoundGrid1.Model.ColStyles[2].BackColor = Color.Red;  

			this.gridDataBoundGrid1.Model.CellModels.Remove("ColumnHeaderCell"); 
			this.gridDataBoundGrid1.Model.CellModels.Add("ColumnHeaderCell",new HeaderCellButtonModel(this.gridDataBoundGrid1.Model ));  
			this.gridDataBoundGrid1.Model.RowHeights.ResizeToFit(GridRangeInfo.Table());   
		}

		#region DataTables

		private int numberParentRows = 5;
		private int numberChildRows = 20;
		
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec"));
			

			for(int i = 0;i < 5;i++)
				dt.Columns.Add();  
			dt.Columns.Add(new DataColumn("Date",typeof(DateTime)));
			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				for(int j = 3;j < 7;j++)
				{
					dr[j] = "Column" + j;
				}
				dr[8] = DateTime.Now; 
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			dt.Columns.Add(new DataColumn("other")); //upper case P
			dt.Columns.Add(new DataColumn("otherx")); //upper case P
			for(int i = 0;i < 5;i++)
				dt.Columns.Add(); 
			
			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				dr[3] = string.Format("other{0}",i);
				dr[4] = string.Format("otherx{0}",i);

				for(int j = 5;j < 9;j++)
				{
					dr[j] = "Column" + j;
				}
				dt.Rows.Add(dr);
			}
		
			return dt;
		}

		
		#endregion
	}

	public class HeaderCellButton : GridCellButton
	{
		BrushInfo m_interiorBrush;
		Rectangle m_bounds;
		Graphics m_graphics;
		ButtonState m_buttonState;
		GridStyleInfo m_gridStyleInfo;
        
		public HeaderCellButton(GridCellRendererBase control)
			: base(control)
		{
			m_interiorBrush = new BrushInfo(GradientStyle.PathRectangle, Color.NavajoWhite, Color.Beige);
            
		}

		public new Rectangle Bounds
		{
			get
			{
				return this.m_bounds;
			}
			set
			{
				m_bounds = value;
			}
		}

		public Graphics Graphics
		{
			get
			{
				return this.m_graphics;
			}
			set
			{
				m_graphics = value;
			}
		}	  
              
		public BrushInfo Interior
		{
			get
			{
				return this.m_interiorBrush;
			}
			set
			{
				m_interiorBrush = value;
			}
		}

		public ButtonState ButtonState
		{
			get
			{
				return this.m_buttonState;
			}
			set
			{
				m_buttonState = value;
			}
		}

		public GridStyleInfo GridStyleInfo
		{
			get
			{
				return this.m_gridStyleInfo;
			}
			set
			{
				m_gridStyleInfo = value;
			}
		}

		public void Draw(int row, int col)
		{
        
			this.Draw(m_graphics, row, col, true, m_gridStyleInfo);
			// this.DrawButton(m_graphics, m_bounds, m_buttonState, m_gridStyleInfo);
		}	
	
	} // -- public class HeaderCellButton

	public class HeaderCellButtonRenderer : GridSortColumnHeaderCellRenderer
	{
		HeaderCellButton m_headerButton;

		public HeaderCellButtonRenderer(GridControlBase grid, GridCellModelBase cellModel)
			: base(grid, cellModel)
		{
			m_headerButton = new HeaderCellButton(this);               
			AddButton(m_headerButton);
			m_headerButton.Interior = new BrushInfo(System.Drawing.SystemColors.Control);
		}
		protected override Rectangle OnLayout(int rowIndex, int colIndex, GridStyleInfo style, Rectangle innerBounds, Rectangle[] buttonsBounds)
		{
			buttonsBounds[0] =new Rectangle(innerBounds.X,innerBounds.Y,innerBounds.Size.Width,innerBounds.Size.Height/2);
			return new Rectangle(innerBounds.X,innerBounds.Y +( innerBounds.Size.Height/2),innerBounds.Size.Width,innerBounds.Size.Height/2);;
		}
		protected override void OnButtonClicked(int rowIndex, int colIndex, int button)
		{
			MessageBox.Show("Override Method of the OnButtonClicked in a HeaderCellButtonRenderer class","Button Clicked"); 
			base.OnButtonClicked (rowIndex, colIndex, button);
		}


	}

	[Serializable]
	public class HeaderCellButtonModel : GridSortColumnHeaderCellModel
	{
		protected HeaderCellButtonModel(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
		}

		public HeaderCellButtonModel(GridModel _gridModel)
			: base(_gridModel)
		{
			AllowFloating = false;
		}

		public override GridCellRendererBase CreateRenderer(GridControlBase control)
		{
			return new HeaderCellButtonRenderer(control, this);
		}
		public override Size CalculatePreferredCellSize(Graphics g, int rowIndex, int colIndex, GridStyleInfo style, GridQueryBounds queryBounds)
		{
			Size size = base.CalculatePreferredCellSize (g, rowIndex, colIndex, style, queryBounds);

			return new Size(size.Width ,2*size.Height); 
			
		}

	}
}
